// Generated by gtkmmproc -- DO NOT MODIFY!


#include <gstreamermm/index.h>
#include <gstreamermm/private/index_p.h>

// -*- Mode: C++; indent-tabs-mode: nil; c-basic-offset: 2 -*-

/* gstreamermm - a C++ wrapper for gstreamer
 *
 * Copyright 2008 The gstreamermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gst/gstindex.h>

namespace Gst
{

static gboolean SignalProxy_SlotIndexFilter(GstIndex* index, GstIndexEntry* entry, gpointer data)
{
  Index::SlotIndexFilter * the_slot = static_cast<Index::SlotIndexFilter*>(data);
  
  IndexEntry cpp_entry = Glib::wrap(entry, true);
  const gboolean result = (*the_slot)(cpp_entry);
  return result;
}


static void SignalProxy_SlotIndexDestroy(gpointer data)
{
  Index::SlotIndexFilter* the_slot = static_cast<Index::SlotIndexFilter*>(data);
  if(the_slot)
    delete the_slot;
}

static gboolean SignalProxy_SlotIndexResolver(GstIndex *index, GstObject *writer, gchar **writer_string, gpointer data)
{
  Index::SlotIndexResolver * the_slot = static_cast<Index::SlotIndexResolver*>(data);

  Glib::RefPtr<Gst::Object> cpp_writer = Glib::wrap(writer, true);
  Glib::ustring cpp_writer_string;
  const gboolean result = (*the_slot)(cpp_writer, cpp_writer_string);
  
  if(writer_string)
  {
    *writer_string = g_strdup(cpp_writer_string.c_str());
  }

  return result;
}

void Index::set_filter(const SlotIndexFilter& slot)
{
  SlotIndexFilter* slot_copy = new SlotIndexFilter(slot); //Deleted in SignalProxy_SlotIndexDestroy.
  gst_index_set_filter_full(gobj(), &SignalProxy_SlotIndexFilter, slot_copy, &SignalProxy_SlotIndexDestroy);
}

void Index::set_resolver(const SlotIndexResolver& slot)
{
  //TODO: We need a destroy callback to destroy the slot_copy.
  SlotIndexResolver* slot_copy = new SlotIndexResolver(slot); 
  gst_index_set_resolver(gobj(), &SignalProxy_SlotIndexResolver, slot_copy);
}

}//namespace Gst

namespace
{
} // anonymous namespace


namespace Glib
{

Gst::IndexEntry wrap(GstIndexEntry* object, bool take_copy /* = false */)
{
  return Gst::IndexEntry(object, take_copy);
}

} // namespace Glib


namespace Gst
{


IndexEntry::IndexEntry()
:
  gobject_ (0) // Allows creation of invalid wrapper, e.g. for output arguments to methods.
{}

IndexEntry::IndexEntry(const IndexEntry& src)
:
  gobject_ ((src.gobject_) ? gst_index_entry_copy(src.gobject_) : 0)
{}

IndexEntry::IndexEntry(GstIndexEntry* castitem, bool make_a_copy /* = false */)
{
  if(!make_a_copy)
  {
    // It was given to us by a function which has already made a copy for us to keep.
    gobject_ = castitem;
  }
  else
  {
    // We are probably getting it via direct access to a struct,
    // so we can not just take it - we have to take a copy of it.
    if(castitem)
      gobject_ = gst_index_entry_copy(castitem);
    else
      gobject_ = 0;
  }
}

IndexEntry& IndexEntry::operator=(const IndexEntry& src)
{
  GstIndexEntry *const new_gobject = (src.gobject_) ? gst_index_entry_copy(src.gobject_) : 0;

  if(gobject_)
    gst_index_entry_free(gobject_);

  gobject_ = new_gobject;

  return *this;
}

IndexEntry::~IndexEntry()
{
  if(gobject_)
    gst_index_entry_free(gobject_);
}

GstIndexEntry* IndexEntry::gobj_copy() const
{
  return gst_index_entry_copy(gobject_);
}


bool IndexEntry::assoc_map(Format format, gint64& value)
{
  return gst_index_entry_assoc_map(gobj(), ((GstFormat)(format)), &(value));
}


} // namespace Gst


namespace Gst
{


} // namespace Gst


namespace Gst
{


} // namespace Gst


namespace Glib
{

Glib::RefPtr<Gst::Index> wrap(GstIndex* object, bool take_copy)
{
  return Glib::RefPtr<Gst::Index>( dynamic_cast<Gst::Index*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Gst
{


/* The *_Class implementation: */

const Glib::Class& Index_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &Index_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(gst_index_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:

  }

  return *this;
}

void Index_Class::class_init_function(void* g_class, void* class_data)
{
  BaseClassType *const klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
}

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


Glib::ObjectBase* Index_Class::wrap_new(GObject* object)
{
  return new Index((GstIndex*)object);
}


/* The implementation: */

GstIndex* Index::gobj_copy()
{
  reference();
  return gobj();
}

Index::Index(const Glib::ConstructParams& construct_params)
:
  Object(construct_params)
{

}

Index::Index(GstIndex* castitem)
:
  Object((GstObject*)(castitem))
{}

Index::~Index()
{}


Index::CppClassType Index::index_class_; // initialize static member

GType Index::get_type()
{
  return index_class_.init().get_type();
}

GType Index::get_base_type()
{
  return gst_index_get_type();
}

Index::Index()
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Object(Glib::ConstructParams(index_class_.init()))
{
  

}

bool Index::is_readable() const
{
  return GST_INDEX_IS_READABLE(const_cast<GstIndex*>(gobj()));
}

bool Index::is_writable() const
{
  return GST_INDEX_IS_WRITABLE(const_cast<GstIndex*>(gobj()));
}

void Index::commit(int id)
{
gst_index_commit(gobj(), id); 
}

gint Index::get_group() const
{
  return gst_index_get_group(const_cast<GstIndex*>(gobj()));
}

gint Index::new_group()
{
  return gst_index_new_group(gobj());
}

bool Index::set_group(int group_number)
{
  return gst_index_set_group(gobj(), group_number);
}

void Index::set_certainty(IndexCertainty certainty)
{
gst_index_set_certainty(gobj(), ((GstIndexCertainty)(certainty))); 
}

IndexCertainty Index::set_certainty() const
{
  return ((IndexCertainty)(gst_index_get_certainty(const_cast<GstIndex*>(gobj()))));
}

bool Index::get_writer_id(const Glib::RefPtr<Gst::Object>& writer, int& id) const
{
  return gst_index_get_writer_id(const_cast<GstIndex*>(gobj()), Glib::unwrap(writer), &id);
}

IndexEntry Index::add_format(int id, Format format)
{
  return Glib::wrap(gst_index_add_format(gobj(), id, ((GstFormat)(format))));
}

IndexEntry Index::add_association(int id, AssocFlags flags, int n, const IndexAssociation& list)
{
  return Glib::wrap(gst_index_add_associationv(gobj(), id, ((GstAssocFlags)(flags)), n, ((GstIndexAssociation*)(&(list)))));
}

IndexEntry Index::add_id(int id, const Glib::ustring& description)
{
  return Glib::wrap(gst_index_add_id(gobj(), id, const_cast<gchar*>(description.c_str())));
}

IndexEntry Index::get_assoc_entry(int id, IndexLookupMethod method, AssocFlags flags, Format format, gint64 value) const
{
  return Glib::wrap(gst_index_get_assoc_entry(const_cast<GstIndex*>(gobj()), id, ((GstIndexLookupMethod)(method)), ((GstAssocFlags)(flags)), ((GstFormat)(format)), value));
}


#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED


} // namespace Gst


